commit a295076bee293aa3112c615f9af7a27231816a36
Author: liuhongt <hongtao.liu@intel.com>
Date:   Wed Jul 24 05:29:23 2024

    Refine constraint "Bk" to define_special_memory_constraint.
    
    For below pattern, RA may still allocate r162 as v/k register, try to
    reload for address with leaq __libc_tsd_CTYPE_B@gottpoff(%rip), %rsi
    which result a linker error.
    
    (set (reg:DI 162)
         (mem/u/c:DI
           (const:DI (unspec:DI
                     [(symbol_ref:DI ("a") [flags 0x60]  <var_decl 0x7f621f6e1c60 a>)]
                     UNSPEC_GOTNTPOFF))
    
    Quote from H.J for why linker issue an error.
    >What do these do:
    >
    >        leaq    __libc_tsd_CTYPE_B@gottpoff(%rip), %rax
    >        vmovq   (%rax), %xmm0
    >
    >From x86-64 TLS psABI:
    >
    >The assembler generates for the x@gottpoff(%rip) expressions a R X86
    >64 GOTTPOFF relocation for the symbol x which requests the linker to
    >generate a GOT entry with a R X86 64 TPOFF64 relocation. The offset of
    >the GOT entry relative to the end of the instruction is then used in
    >the instruction. The R X86 64 TPOFF64 relocation is pro- cessed at
    >program startup time by the dynamic linker by looking up the symbol x
    >in the modules loaded at that point. The offset is written in the GOT
    >entry and later loaded by the addq instruction.
    >
    >The above code sequence looks wrong to me.
    
    gcc/ChangeLog:
    
            PR target/116043
            * config/i386/constraints.md (Bk): Refine to
            define_special_memory_constraint.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/i386/pr116043.c: New test.
    
    (cherry picked from commit bc1fda00d5f20e2f3e77a50b2822562b6e0040b2)

diff --git a/gcc/testsuite/gcc.target/i386/pr116043.c b/gcc/testsuite/gcc.target/i386/pr116043.c
new file mode 100644
index 00000000000..76553496c10
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr116043.c
@@ -0,0 +1,33 @@
+/* { dg-do compile } */
+/* { dg-options "-mavx512bf16 -O3" } */
+/* { dg-final { scan-assembler-not {(?n)lea.*@gottpoff} } } */
+
+extern __thread int a, c, i, j, k, l;
+int *b;
+struct d {
+  int e;
+} f, g;
+char *h;
+
+void m(struct d *n) {
+  b = &k;
+  for (; n->e; b++, n--) {
+    i = b && a;
+    if (i)
+      j = c;
+  }
+}
+
+char *o(struct d *n) {
+  for (; n->e;)
+    return h;
+}
+
+int q() {
+  if (l)
+    return 1;
+  int p = *o(&g);
+  m(&f);
+  m(&g);
+  l = p;
+}

